"use strict";

var _cypressCucumberPreprocessor = require("@badeball/cypress-cucumber-preprocessor");
(0, _cypressCucumberPreprocessor.Given)('a SplitButton is rendered', () => {
  cy.visitStory('SplitButton', 'Default');
});
(0, _cypressCucumberPreprocessor.Given)('the SplitButton menu is open', () => {
  cy.get('[data-test="dhis2-uicore-splitbutton-toggle"]').click();
  cy.get('[data-test="dhis2-uicore-splitbutton-menu"]').should('be.visible');
});
(0, _cypressCucumberPreprocessor.Given)('the SplitButton menu is closed', () => {
  cy.get('[data-test="dhis2-uicore-splitbutton-menu"]').should('not.exist');
});
(0, _cypressCucumberPreprocessor.When)('the user clicks the backdrop Layer', () => {
  cy.get('[data-test="dhis2-uicore-layer"]').click();
});
(0, _cypressCucumberPreprocessor.Then)('the menu is not visible', () => {
  cy.get('[data-test="dhis2-uicore-splitbutton-menu"]').should('not.exist');
});
(0, _cypressCucumberPreprocessor.Then)('the component is not visible', () => {
  cy.contains('Component').should('not.exist');
});
(0, _cypressCucumberPreprocessor.Then)('the menu is visible', () => {
  cy.get('[data-test="dhis2-uicore-splitbutton-menu"]').should('be.visible');
});
(0, _cypressCucumberPreprocessor.Then)('the component is visible', () => {
  cy.contains('Component').should('be.visible');
});